This folder contains the code for the paper 'Masks, Signs, and Learning Rate Rewinding' which is presently under review.

Example run for IMP:
` python main.py --seed 1 --config configs/largescale/resnet18-cifar-str-1.yaml --resnet-type large --threshold-list 0.8 0.64 0.51 --multigpu 0 --pruner mag --reset-weights --name cifar-imp-rewind  --final_prune_epoch 150 --result-dir cifar-results --warmup-epochs 50 --prune-scheduler cosine-warmup --expt-setup rml --lr 0.1 `

Example run to load disentangle model weights, mask and signs

` python main.py --seed 1 --resnet-type res50 --config configs/largescale/resnet18-cifar100-str-1.yaml --threshold-list  --multigpu 0 --pruner none --name cifar100-res50-imp-init-lrr-mask-lrr-learnt-sign-warmup-every-cycle-seed-1-level-8 --final_prune_epoch 150 --result-dir cifar-results --warmup-epochs 0 --load-model-mask-and-sign --load-model-name model_cifar100-res50-imp-rewind-warmup-every-cycle-seed-1_init.pt --load-mask-name mask_cifar100-res50-lrr-warmup-every-cycle-seed-1-level-7.pt --load-model-sign-name model_cifar100-res50-lrr-warmup-every-cycle-seed-1-level-8.pt --prune-scheduler step-warmup --expt-setup local --lr 0.1', shell=True) `

Example run for single hidden neuron network for LRR and IMP

` python finetune_theory_example.py --optimizer lbfgs --result-dir results --init-case 1 --name LRR --dim 10 --num-samples 500 --prune-iters 3 --epochs 1000 --seed 1 --noise 0.1 --density 0.1`

` python finetune_theory_example.py --optimizer lbfgs --result-dir results --reset-weights --init-case 1 --name IMP --dim 10 --num-samples 500 --prune-iters 3 --epochs 1000 --seed 1 --noise 0.1 --density 0.1`
